      subroutine u3dbc_interp_tile(Istr,Iend,Jstr,Jend)      

      use AGRIF_Util
#include "Param_BeforeCall_u3dbc_interp_tile.h"
      integer(4) :: Istr
      integer(4) :: Iend
      integer(4) :: Jstr
      integer(4) :: Jend
      

        call Sub_Loop_u3dbc_interp_tile(Istr,Iend,Jstr,Jend, Agrif_tabva
     &rs_i(8)%iarray0, Agrif_tabvars_i(13)%iarray0, Agrif_tabvars_i(2)%i
     &array0, Agrif_tabvars_i(14)%iarray0, Agrif_tabvars_i(4)%iarray0, A
     &grif_tabvars_i(7)%iarray0, Agrif_tabvars(68)%array4, Agrif_tabvars
     &(191)%array2, Agrif_tabvars(71)%array4, Agrif_tabvars(203)%array2,
     & Agrif_tabvars(62)%array4, Agrif_tabvars(167)%array2, Agrif_tabvar
     &s(79)%array2, Agrif_tabvars_i(153)%iarray0, Agrif_tabvars(150)%arr
     &ay4, Agrif_tabvars(65)%array4, Agrif_tabvars(179)%array2, Agrif_ta
     &bvars_i(156)%iarray0, Agrif_tabvars_i(211)%iarray0, Agrif_tabvars_
     &i(234)%iarray0, Agrif_tabvars_i(155)%iarray0, Agrif_tabvars_i(231)
     &%iarray0, Agrif_tabvars_l(13)%larray0, Agrif_tabvars_l(14)%larray0
     &, Agrif_tabvars_l(11)%larray0, Agrif_tabvars_l(12)%larray0)

      end


#include "Sub_Loop_u3dbc_interp_tile.h"
      subroutine u3Dinterp(tabres,i1,i2,j1,j2,k1,k2,before,nb,ndir)      


      use Agrif_Util
#include "Param_BeforeCall_u3Dinterp.h"
      integer(4) :: i1
      integer(4) :: i2
      integer(4) :: j1
      integer(4) :: j2
      integer(4) :: k1
      integer(4) :: k2
      real, dimension(i1:i2,j1:j2,k1:k2) :: tabres
      logical :: before
      integer(4) :: nb
      integer(4) :: ndir
      

        call Sub_Loop_u3Dinterp(tabres,i1,i2,j1,j2,k1,k2,before,nb,ndir,
     & Agrif_tabvars_i(8)%iarray0, Agrif_tabvars_i(13)%iarray0, Agrif_ta
     &bvars_i(2)%iarray0, Agrif_tabvars_i(14)%iarray0, Agrif_tabvars_i(4
     &)%iarray0, Agrif_tabvars_i(7)%iarray0, Agrif_tabvars(68)%array4, A
     &grif_tabvars_l(11)%larray0, Agrif_tabvars(71)%array4, Agrif_tabvar
     &s_l(12)%larray0, Agrif_tabvars(62)%array4, Agrif_tabvars_l(13)%lar
     &ray0, Agrif_tabvars(65)%array4, Agrif_tabvars_l(14)%larray0, Agrif
     &_tabvars(150)%array4, Agrif_tabvars_i(155)%iarray0, Agrif_tabvars_
     &i(152)%iarray0)

      end


#include "Sub_Loop_u3Dinterp.h"
      subroutine v3dbc_interp_tile(Istr,Iend,Jstr,Jend)      

      use AGRIF_Util
#include "Param_BeforeCall_v3dbc_interp_tile.h"
      integer(4) :: Istr
      integer(4) :: Iend
      integer(4) :: Jstr
      integer(4) :: Jend
      

        call Sub_Loop_v3dbc_interp_tile(Istr,Iend,Jstr,Jend, Agrif_tabva
     &rs_i(8)%iarray0, Agrif_tabvars_i(13)%iarray0, Agrif_tabvars_i(2)%i
     &array0, Agrif_tabvars_i(14)%iarray0, Agrif_tabvars_i(4)%iarray0, A
     &grif_tabvars_i(7)%iarray0, Agrif_tabvars(67)%array4, Agrif_tabvars
     &(189)%array2, Agrif_tabvars(70)%array4, Agrif_tabvars(201)%array2,
     & Agrif_tabvars(61)%array4, Agrif_tabvars(165)%array2, Agrif_tabvar
     &s(78)%array2, Agrif_tabvars_i(153)%iarray0, Agrif_tabvars(149)%arr
     &ay4, Agrif_tabvars(64)%array4, Agrif_tabvars(177)%array2, Agrif_ta
     &bvars_i(156)%iarray0, Agrif_tabvars_i(210)%iarray0, Agrif_tabvars_
     &i(233)%iarray0, Agrif_tabvars_i(155)%iarray0, Agrif_tabvars_i(231)
     &%iarray0, Agrif_tabvars_l(13)%larray0, Agrif_tabvars_l(14)%larray0
     &, Agrif_tabvars_l(11)%larray0, Agrif_tabvars_l(12)%larray0)

      end


#include "Sub_Loop_v3dbc_interp_tile.h"
      subroutine v3Dinterp(tabres,i1,i2,j1,j2,k1,k2,before,nb,ndir)      


      use Agrif_Util
#include "Param_BeforeCall_v3Dinterp.h"
      integer(4) :: i1
      integer(4) :: i2
      integer(4) :: j1
      integer(4) :: j2
      integer(4) :: k1
      integer(4) :: k2
      real, dimension(i1:i2,j1:j2,k1:k2) :: tabres
      logical :: before
      integer(4) :: nb
      integer(4) :: ndir
      

        call Sub_Loop_v3Dinterp(tabres,i1,i2,j1,j2,k1,k2,before,nb,ndir,
     & Agrif_tabvars_i(8)%iarray0, Agrif_tabvars_i(13)%iarray0, Agrif_ta
     &bvars_i(2)%iarray0, Agrif_tabvars_i(14)%iarray0, Agrif_tabvars_i(4
     &)%iarray0, Agrif_tabvars_i(7)%iarray0, Agrif_tabvars(67)%array4, A
     &grif_tabvars_l(11)%larray0, Agrif_tabvars(70)%array4, Agrif_tabvar
     &s_l(12)%larray0, Agrif_tabvars(61)%array4, Agrif_tabvars_l(13)%lar
     &ray0, Agrif_tabvars(64)%array4, Agrif_tabvars_l(14)%larray0, Agrif
     &_tabvars(149)%array4, Agrif_tabvars_i(155)%iarray0, Agrif_tabvars_
     &i(152)%iarray0)

      end


#include "Sub_Loop_v3Dinterp.h"
      subroutine t3dbc_interp_tile(Istr,Iend,Jstr,Jend,indx,itrc)      

      use AGRIF_Util
#include "Param_BeforeCall_t3dbc_interp_tile.h"
      integer(4) :: Istr
      integer(4) :: Iend
      integer(4) :: Jstr
      integer(4) :: Jend
      integer(4) :: indx
      integer(4) :: itrc
      

        call Sub_Loop_t3dbc_interp_tile(Istr,Iend,Jstr,Jend,indx,itrc, A
     &grif_tabvars_i(8)%iarray0, Agrif_tabvars_i(13)%iarray0, Agrif_tabv
     &ars_i(2)%iarray0, Agrif_tabvars_i(14)%iarray0, Agrif_tabvars_i(4)%
     &iarray0, Agrif_tabvars_i(7)%iarray0, Agrif_tabvars(69)%array5, Agr
     &if_tabvars(187)%array3, Agrif_tabvars(72)%array5, Agrif_tabvars(19
     &9)%array3, Agrif_tabvars(63)%array5, Agrif_tabvars(163)%array3, Ag
     &rif_tabvars(81)%array2, Agrif_tabvars(66)%array5, Agrif_tabvars(17
     &5)%array3, Agrif_tabvars_i(209)%iarray0, Agrif_tabvars_i(235)%iarr
     &ay0, Agrif_tabvars_i(155)%iarray0, Agrif_tabvars_i(231)%iarray0, A
     &grif_tabvars_i(156)%iarray0, Agrif_tabvars_l(13)%larray0, Agrif_ta
     &bvars_l(14)%larray0, Agrif_tabvars_l(11)%larray0, Agrif_tabvars_l(
     &12)%larray0)

      end


#include "Sub_Loop_t3dbc_interp_tile.h"
      subroutine t3Dinterp(tabres,i1,i2,j1,j2,k1,k2,m1,m2,before,
     &                     nb,ndir)      


      use Agrif_Util
#include "Param_BeforeCall_t3Dinterp.h"
      integer(4) :: i1
      integer(4) :: i2
      integer(4) :: j1
      integer(4) :: j2
      integer(4) :: k1
      integer(4) :: k2
      integer(4) :: m1
      integer(4) :: m2
      real, dimension(i1:i2,j1:j2,k1:k2,m1:m2) :: tabres
      logical :: before
      integer(4) :: nb
      integer(4) :: ndir
      

        call Sub_Loop_t3Dinterp(tabres,i1,i2,j1,j2,k1,k2,m1,m2,before,nb
     &,ndir, Agrif_tabvars_i(8)%iarray0, Agrif_tabvars_i(13)%iarray0, Ag
     &rif_tabvars_i(2)%iarray0, Agrif_tabvars_i(14)%iarray0, Agrif_tabva
     &rs_i(4)%iarray0, Agrif_tabvars_i(7)%iarray0, Agrif_tabvars(69)%arr
     &ay5, Agrif_tabvars_l(11)%larray0, Agrif_tabvars(72)%array5, Agrif_
     &tabvars_l(12)%larray0, Agrif_tabvars(63)%array5, Agrif_tabvars_l(1
     &3)%larray0, Agrif_tabvars(66)%array5, Agrif_tabvars_l(14)%larray0,
     & Agrif_tabvars(148)%array5, Agrif_tabvars_i(155)%iarray0, Agrif_ta
     &bvars_i(152)%iarray0)

      end


#include "Sub_Loop_t3Dinterp.h"
